'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UsersRouter = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _deepcopy = require('deepcopy');

var _deepcopy2 = _interopRequireDefault(_deepcopy);

var _ClassesRouter2 = require('./ClassesRouter');

var _ClassesRouter3 = _interopRequireDefault(_ClassesRouter2);

var _PromiseRouter = require('../PromiseRouter');

var _PromiseRouter2 = _interopRequireDefault(_PromiseRouter);

var _rest = require('../rest');

var _rest2 = _interopRequireDefault(_rest);

var _Auth = require('../Auth');

var _Auth2 = _interopRequireDefault(_Auth);

var _password = require('../password');

var _password2 = _interopRequireDefault(_password);

var _RestWrite = require('../RestWrite');

var _RestWrite2 = _interopRequireDefault(_RestWrite);

var _cryptoUtils = require('../cryptoUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // These methods handle the User-related routes.

var UsersRouter = exports.UsersRouter = function (_ClassesRouter) {
  _inherits(UsersRouter, _ClassesRouter);

  function UsersRouter() {
    _classCallCheck(this, UsersRouter);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(UsersRouter).apply(this, arguments));
  }

  _createClass(UsersRouter, [{
    key: 'handleFind',
    value: function handleFind(req) {
      req.params.className = 'users';
      return _get(Object.getPrototypeOf(UsersRouter.prototype), 'handleFind', this).call(this, req);
    }
  }, {
    key: 'handleGet',
    value: function handleGet(req) {
      req.params.className = 'users';
      return _get(Object.getPrototypeOf(UsersRouter.prototype), 'handleGet', this).call(this, req);
    }
  }, {
    key: 'handleCreate',
    value: function handleCreate(req) {
      var data = (0, _deepcopy2.default)(req.body);
      req.body = data;
      req.params.className = 'users';
      return _get(Object.getPrototypeOf(UsersRouter.prototype), 'handleCreate', this).call(this, req);
    }
  }, {
    key: 'handleUpdate',
    value: function handleUpdate(req) {
      req.params.className = 'users';
      return _get(Object.getPrototypeOf(UsersRouter.prototype), 'handleUpdate', this).call(this, req);
    }
  }, {
    key: 'handleDelete',
    value: function handleDelete(req) {
      req.params.className = 'users';
      return _get(Object.getPrototypeOf(UsersRouter.prototype), 'handleDelete', this).call(this, req);
    }
  }, {
    key: 'handleMe',
    value: function handleMe(req) {
      if (!req.info || !req.info.sessionToken) {
        throw new Parse.Error(Parse.Error.INVALID_SESSION_TOKEN, 'invalid session token');
      }
      return _rest2.default.find(req.config, _Auth2.default.master(req.config), '_Session', { _session_token: req.info.sessionToken }, { include: 'user' }).then(function (response) {
        if (!response.results || response.results.length == 0 || !response.results[0].user) {
          throw new Parse.Error(Parse.Error.INVALID_SESSION_TOKEN, 'invalid session token');
        } else {
          var user = response.results[0].user;
          return { response: user };
        }
      });
    }
  }, {
    key: 'handleLogIn',
    value: function handleLogIn(req) {
      // Use query parameters instead if provided in url
      if (!req.body.username && req.query.username) {
        req.body = req.query;
      }

      // TODO: use the right error codes / descriptions.
      if (!req.body.username) {
        throw new Parse.Error(Parse.Error.USERNAME_MISSING, 'username is required.');
      }
      if (!req.body.password) {
        throw new Parse.Error(Parse.Error.PASSWORD_MISSING, 'password is required.');
      }

      var user = undefined;
      return req.database.find('users', { username: req.body.username }).then(function (results) {
        if (!results.length) {
          throw new Parse.Error(Parse.Error.OBJECT_NOT_FOUND, 'Invalid username/password.');
        }
        user = results[0];
        return _password2.default.compare(req.body.password, user.password);
      }).then(function (correct) {
        if (!correct) {
          throw new Parse.Error(Parse.Error.OBJECT_NOT_FOUND, 'Invalid username/password.');
        }

        var token = 'r:' + (0, _cryptoUtils.newToken)();
        user.sessionToken = token;
        delete user.password;

        req.config.filesController.expandFilesInObject(req.config, user);

        var expiresAt = new Date();
        expiresAt.setFullYear(expiresAt.getFullYear() + 1);

        var sessionData = {
          sessionToken: token,
          user: {
            __type: 'Pointer',
            className: 'users',
            objectId: user.objectId
          },
          createdWith: {
            'action': 'login',
            'authProvider': 'password'
          },
          restricted: false,
          expiresAt: Parse._encode(expiresAt)
        };

        if (req.info.installationId) {
          sessionData.installationId = req.info.installationId;
        }

        var create = new _RestWrite2.default(req.config, _Auth2.default.master(req.config), '_Session', null, sessionData);
        return create.execute();
      }).then(function () {
        return { response: user };
      });
    }
  }, {
    key: 'handleLogOut',
    value: function handleLogOut(req) {
      var success = { response: {} };
      if (req.info && req.info.sessionToken) {
        return _rest2.default.find(req.config, _Auth2.default.master(req.config), '_Session', { _session_token: req.info.sessionToken }).then(function (records) {
          if (records.results && records.results.length) {
            return _rest2.default.del(req.config, _Auth2.default.master(req.config), '_Session', records.results[0].objectId).then(function () {
              return Promise.resolve(success);
            });
          }
          return Promise.resolve(success);
        });
      }
      return Promise.resolve(success);
    }
  }, {
    key: 'mountRoutes',
    value: function mountRoutes() {
      var _this2 = this;

      this.route('GET', '/users', function (req) {
        return _this2.handleFind(req);
      });
      this.route('POST', '/users', function (req) {
        return _this2.handleCreate(req);
      });
      this.route('GET', '/users/me', function (req) {
        return _this2.handleMe(req);
      });
      this.route('GET', '/users/:objectId', function (req) {
        return _this2.handleGet(req);
      });
      this.route('PUT', '/users/:objectId', function (req) {
        return _this2.handleUpdate(req);
      });
      this.route('DELETE', '/users/:objectId', function (req) {
        return _this2.handleDelete(req);
      });
      this.route('GET', '/login', function (req) {
        return _this2.handleLogIn(req);
      });
      this.route('POST', '/logout', function (req) {
        return _this2.handleLogOut(req);
      });
      this.route('POST', '/requestPasswordReset', function () {
        throw new Parse.Error(Parse.Error.COMMAND_UNAVAILABLE, 'This path is not implemented yet.');
      });
    }
  }]);

  return UsersRouter;
}(_ClassesRouter3.default);

exports.default = UsersRouter;